## sayonara 1.8.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.8)
project("Sayonara Player")

option(WITH_DOC "Building with doxygen support" OFF)
option(WITH_TESTS "Building with tests" OFF)
option(WITH_COTIRE "Building with cotire PCH and compile time optimizations" OFF)
option(LINK_GSTREAMER_PLUGINS "Link the most common GStreamer plugins into the binary. Used for the creation of AppImage files")
option(WITH_CCACHE "Use CCache if available" OFF)
option(DISABLE_NATIVE_DIR_DIALOGS "Disable native directory dialogs (problem for snap and flatpak)" OFF)

get_property(HAS_64_SUFFIX GLOBAL PROPERTY FIND_LIBRARY_USE_LIB64_PATHS)
if(HAS_64_SUFFIX)
	set(LIB_SUFFIX "64")
else()
	set(LIB_SUFFIX "")
endif()

set(CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}")

set(SAYONARA_VERSION "1.8.0-beta1")
set(SAYONARA_INSTALL_PATH "${CMAKE_INSTALL_PREFIX}")
set(SAYONARA_INSTALL_PREFIX "${CMAKE_INSTALL_PREFIX}")
set(SAYONARA_INSTALL_BIN_PATH "${CMAKE_INSTALL_PREFIX}/bin/")
set(SAYONARA_INSTALL_LIB_PATH "${CMAKE_INSTALL_PREFIX}/lib${LIB_SUFFIX}/sayonara/")
set(SAYONARA_INSTALL_SHARE_PATH "${CMAKE_INSTALL_PREFIX}/share/sayonara/")

message("Build Sayonara ${VAR_SAYONARA_VERSION}")
message("Will install to ${CMAKE_INSTALL_PREFIX}")

# used for cmakedefine in Macros.h.in
set(SAYONARA_WITH_TESTS ${WITH_TESTS})
string(TOLOWER "${CMAKE_BUILD_TYPE}" LOWER_CMAKE_BUILD_TYPE)
if("${LOWER_CMAKE_BUILD_TYPE}" MATCHES "debug")
	set(SAYONARA_WITH_TESTS 1)
endif()

add_subdirectory(dist)
add_subdirectory(src)
add_subdirectory(resources)

message("Lower cmake build type ${LOWER_CMAKE_BUILD_TYPE}")

if(SAYONARA_WITH_TESTS)
	message("Compiling with tests...")
	enable_testing()
	add_subdirectory(test)
else()
	message("Compiling without tests...")
	message(" In order to change that, use -DWITH_TESTS=1")
endif()

set(CMAKE_INSTALL_MANIFEST "install_manifest.txt")

# doxygen

if (WITH_DOC)
	message ("Looking for doxygen")
	find_package(Doxygen)

	if (DOXYGEN_FOUND)
		message ("Doxygen found")
		set(DOXYFILE_IN "${CMAKE_SOURCE_DIR}/docs/doxygen.in")
		set(DOXYFILE_OUT "${CMAKE_BINARY_DIR}/docs/doxygen.cfg")
		set(DOXYFILE_SRC_DIR "${CMAKE_SOURCE_DIR}")
		set(DOXYFILE_OUTPUT_DIR "${CMAKE_BINARY_DIR}/docs")

		include(FindPerl OPTIONAL)
		set(DOXYFILE_PERL_EXECUTABLE "${PERL_EXECUTABLE}")

		configure_file(${DOXYFILE_IN} ${DOXYFILE_OUT} @ONLY)

		add_custom_target(doc
			COMMAND ${DOXYGEN_EXECUTABLE} ${DOXYFILE_OUT}
			WORKING_DIRECTORY "${CMAKE_SOURCE_DIR}/src"
			COMMENT "Generating documentation..."
			VERBATIM
		)

	install(DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/docs/html DESTINATION share/doc/sayonara/doxygen)

	endif (DOXYGEN_FOUND)
endif (WITH_DOC)

=== dist/CMakeLists.txt ===
execute_process(COMMAND env LC_TIME="en_US.utf8" date "+%a %b %d %Y" OUTPUT_VARIABLE SAYONARA_DATE_TODAY)
string(REGEX REPLACE "\n$" "" SAYONARA_DATE_TODAY "${SAYONARA_DATE_TODAY}")
string(REGEX MATCH "[0-9]+(\.[0-9])+" SAYONARA_VERSION_BASE "${SAYONARA_VERSION}")
string(REGEX MATCH "[a-z]+[0-9]+" SAYONARA_VERSION_RELEASE ${SAYONARA_VERSION})

configure_file(${CMAKE_CURRENT_SOURCE_DIR}/rpm/sayonara.spec.in ${CMAKE_CURRENT_BINARY_DIR}/sayonara.spec @ONLY)

=== resources/CMakeLists.txt ===
project(say_resources)

configure_file(version.in ${CMAKE_BINARY_DIR}/version @ONLY)

# manpage
find_program(GZIP_BINARY
             NAMES gzip)

if (NOT GZIP_BINARY)
    message("gzip not found. No manpage will be created")
else ()
    ## create date for manpage
    string(TIMESTAMP SAYONARA_MANPAGE_DATE "%d %B %Y" UTC)

    ## create manpages
    configure_file(sayonara.1.man.in
                   ${CMAKE_CURRENT_BINARY_DIR}/sayonara.1
                   @ONLY)
    configure_file(sayonara-ctl.1.man.in
                   ${CMAKE_CURRENT_BINARY_DIR}/sayonara-ctl.1
                   @ONLY)
    configure_file(sayonara-query.1.man.in
                   ${CMAKE_CURRENT_BINARY_DIR}/sayonara-query.1
                   @ONLY)

    ## create zipped manpage
    execute_process(COMMAND gzip -kf ${CMAKE_CURRENT_BINARY_DIR}/sayonara.1)
    execute_process(COMMAND gzip -kf ${CMAKE_CURRENT_BINARY_DIR}/sayonara-ctl.1)
    execute_process(COMMAND gzip -kf ${CMAKE_CURRENT_BINARY_DIR}/sayonara-query.1)

    install(FILES "${CMAKE_CURRENT_BINARY_DIR}/sayonara.1.gz"
            DESTINATION share/man/man1)
    install(FILES "${CMAKE_CURRENT_BINARY_DIR}/sayonara-ctl.1.gz"
            DESTINATION share/man/man1)
    install(FILES "${CMAKE_CURRENT_BINARY_DIR}/sayonara-query.1.gz"
            DESTINATION share/man/man1)
endif ()

install(FILES "com.sayonara-player.Sayonara.desktop"
        DESTINATION share/applications)
install(FILES "sayonara.appdata.xml"
        DESTINATION share/metainfo)
install(DIRECTORY "logos/"
        DESTINATION share/icons/hicolor)

=== src/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.8)
project(sayonara)

include(FindPkgConfig)
include(CheckIncludeFileCXX)
include(CMake/Compiler.cmake)
if(LINK_GSTREAMER_PLUGINS)
	include(CMake/GStreamer.cmake)
endif()

# absolute linker paths are no longer supoorted in -l parameter
# use -L for path and -l for library itself
if(POLICY CMP0003)
	cmake_policy(SET CMP0003 NEW)
endif()

# no more escaping of preprocessor definitions
if(POLICY CMP0005)
	cmake_policy(SET CMP0005 NEW)
endif()

# Run Automoc/Autouic over autogenerated source files (e.g. from qrc files)
if(POLICY CMP0071)
	cmake_policy(SET CMP0071 NEW)
endif()

if(WITH_COTIRE)
	include(CMake/Cotire.cmake)
	message("Compiling with Cotire")
	add_definitions(-D__STRICT_ANSI__)
else()
	message("Compiling without Cotire")
endif()

pkg_check_modules(GLIB glib-2.0 REQUIRED)
pkg_check_modules(GOBJECT gobject-2.0 REQUIRED)
pkg_check_modules(GSTREAMER gstreamer-1.0 REQUIRED)
pkg_check_modules(GSTREAMER_BASE gstreamer-base-1.0 REQUIRED)
pkg_check_modules(GSTREAMER_BASE_APP gstreamer-app-1.0 REQUIRED)
pkg_check_modules(ZLIB REQUIRED zlib REQUIRED)
pkg_check_modules(TAGLIB REQUIRED taglib REQUIRED)

if(WIN32)
	pkg_check_modules(GIO gio-windows-2.0 REQUIRED)
elseif(GSTREAMER_PLUGIN_LIBRARIES)
	pkg_check_modules(GIO gio-2.0 REQUIRED)
endif()

set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/bin)
set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/lib)

if( NOT DEFINED CMAKE_BUILD_TYPE OR NOT CMAKE_BUILD_TYPE )
	message("Use standard build type \"Release\"")
	set(CMAKE_BUILD_TYPE "Release")
endif()

# in order to choose another qt installation set CMAKE_PREFIX_PATH
find_package(Qt5 5.8 COMPONENTS Core Widgets Sql Network DBus Xml Svg REQUIRED)
find_package(Qt5LinguistTools REQUIRED)

include_directories(${Qt5Core_INCLUDE_DIRS})
include_directories(${Qt5Widgets_INCLUDE_DIRS})
include_directories(${Qt5Xml_INCLUDE_DIRS})
include_directories(${Qt5Sql_INCLUDE_DIRS})
include_directories(${Qt5DBus_INCLUDE_DIRS})
include_directories(${Qt5Network_INCLUDE_DIRS})
include_directories(${Qt5Svg_INCLUDE_DIRS})
include_directories(${GLIB_INCLUDE_DIRS})
include_directories(${GOBJECT_INCLUDE_DIRS})
include_directories(${GSTREAMER_INCLUDE_DIRS})
include_directories(${GSTREAMER_BASE_INCLUDE_DIRS})
include_directories(${GSTREAMER_BASE_APP_INCLUDE_DIRS})
include_directories(${TAGLIB_INCLUDE_DIRS})
include_directories(${ZLIB_INCLUDE_DIRS})
include_directories(${CMAKE_CURRENT_SOURCE_DIR})
include_directories(${CMAKE_CURRENT_BINARY_DIR})

add_definitions(${Qt5Core_DEFINITIONS})
add_definitions(${QT_DEFINITIONS})

link_directories(${TAGLIB_LIBRARY_DIRS})
link_directories(${GLIB_LIBRARY_DIRS})
link_directories(${GSTREAMER_LIBRARY_DIRS})

# DBus and Shutdown
if(WIN32)
	message("Windows: host Will compile without dbus and shutdown support")
else()
	message("No Windows: Will compile with dbus and shutdown support")
	# Macros.h.in
	set(SAYONARA_WITH_DBUS 1)
	set(SAYONARA_WITH_SHUTDOWN 1)
	set(WIN32 0)
endif()

if(GIO_LIBRARY_DIRS)
	link_directories(${GIO_LIBRARY_DIRS})
endif()

# check libexecinfo for non-glibc systems
if(NOT WIN32)
	include(CheckSymbolExists)
	message("Checking if backtrace symbol present")
	check_symbol_exists(backtrace execinfo.h backtrace_exists)
	if(NOT backtrace_exists)
		message("backtrace is missing (non-glibc platform), trying to find libexecinfo")
		find_library(execinfo_LIB execinfo)
		if(NOT execinfo_LIB)
			message(FATAL_ERROR "libexecinfo not found")
		endif()
		set(OS_LIBRARIES ${execinfo_LIB})
	else()
		set(SAYONARA_HAS_BACKTRACE 1)
	endif()
endif()

# Check demangle
check_include_file_cxx("cxxabi.h" HAVE_CXX_ABI)
if(${HAVE_CXX_ABI})
	# Macros.h.in
	set(SAYONARA_HAS_CXX_ABI 1)
	message("Compile with demangle")
else()
	message("Demangle not found")
endif()

configure_file(Macros.h.in "${CMAKE_CURRENT_BINARY_DIR}/Utils/Macros.h" @ONLY)

set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTOUIC OFF)
set(CMAKE_INCLUDE_CURRENT_DIR ON)

add_subdirectory(Application)
add_subdirectory(Components)
add_subdirectory(Database)
add_subdirectory(DBus)
add_subdirectory(Interfaces)
add_subdirectory(Gui)
add_subdirectory(Languages)
add_subdirectory(Utils)

qt5_add_resources(DATABASE_RCC
	${CMAKE_CURRENT_SOURCE_DIR}/../resources/Database.qrc
	${CMAKE_CURRENT_SOURCE_DIR}/../resources/Resources.qrc
)

add_executable(${PROJECT_NAME} Main.cpp ${QM_FILES} ${DATABASE_RCC})

if(WIN32)
	set(OS_LIBRARIES
		api-ms-win-core-winrt-l1-1-0
		api-ms-win-core-winrt-string-l1-1-0
		${GIO_LIBRARIES}
	)
endif()

target_link_libraries(${PROJECT_NAME}
	sayonara_application
	sayonara_languages

	${OS_LIBRARIES}
)

add_executable("create-database" CreateDB.cpp ${DATABASE_RCC})
target_link_libraries("create-database"
	sayonara_utils
	sayonara_database
	Qt5::Widgets
)

if(WIN32)
	install(TARGETS ${PROJECT_NAME} DESTINATION .)
else()
	install(TARGETS ${PROJECT_NAME} DESTINATION bin)
endif()

if(GSTREAMER_PLUGIN_LIBRARIES)
	message("Will install gstreamer plugins")

	install(FILES ${GSTREAMER_PLUGIN_LIBRARIES} DESTINATION ${CMAKE_INSTALL_PREFIX}/lib/gstreamer-1.0)
	install(FILES ${GSTREAMER_PLUGIN_SCANNER} DESTINATION ${CMAKE_INSTALL_PREFIX}/lib/gstreamer1.0/gstreamer-1.0)
	install(DIRECTORY ${GLIB_SCHEMA_DIR} DESTINATION ${CMAKE_INSTALL_PREFIX}/share/glib-2.0/)
	install(FILES ${GLIB_SCHEMA} DESTINATION ${CMAKE_INSTALL_PREFIX}/share/glib-2.0/schemas/)
	install(DIRECTORY ${GIO_MODULE_DIR} DESTINATION ${CMAKE_INSTALL_PREFIX}/lib/gio/)
	install(FILES ${GIO_QUERYMODULES} DESTINATION ${CMAKE_INSTALL_PREFIX}/bin/)
endif()

=== test/CMakeLists.txt ===
project(sayonara-test)
include("NewTest.cmake")
include(${CMAKE_SOURCE_DIR}/src/CMake/Compiler.cmake)

if(POLICY CMP0071)
	cmake_policy(SET CMP0071 NEW)
endif()

find_package(Qt5 COMPONENTS Core Gui Sql Network Xml Test REQUIRED)

set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTOUIC ON)
set(CMAKE_INCLUDE_CURRENT_DIR ON)

file(COPY ${CMAKE_SOURCE_DIR}/resources/player.db
	DESTINATION	${CMAKE_CURRENT_BINARY_DIR}
)

include_directories(${Qt5Core_INCLUDE_DIRS})
include_directories(${Qt5Gui_INCLUDE_DIRS})
include_directories(${Qt5Xml_INCLUDE_DIRS})
include_directories(${Qt5Sql_INCLUDE_DIRS})
include_directories(${Qt5Network_INCLUDE_DIRS})
include_directories(${Qt5Test_INCLUDE_DIRS})
include_directories(${CMAKE_CURRENT_SOURCE_DIR}/../src)

add_definitions(${Qt5Core_DEFINITIONS})
add_definitions(${QT_DEFINITIONS})

include_directories(${CMAKE_SOURCE_DIR}/src)
include_directories(${CMAKE_BINARY_DIR}/src)
include_directories(${CMAKE_BINARY_DIR}/src/3rdParty)
include_directories(${CMAKE_BINARY_DIR}/src/3rdParty/taglib)

include_directories(${CMAKE_SOURCE_DIR})
include_directories(${CMAKE_BINARY_DIR}/test)

set(RESOURCES
	resources/Test.qrc
	${CMAKE_CURRENT_SOURCE_DIR}/../resources/Database.qrc
	${CMAKE_CURRENT_SOURCE_DIR}/../resources/Resources.qrc
)

qt5_add_resources(RESOURCES_RCC
	${RESOURCES}
)

new_test(AudioConverter/AudioConverterTest.cpp)

new_test(Covers/CoverLocationTest.cpp)
new_test(Covers/CoverFetchManagerTest.cpp)

new_test(Database/PodcastTest.cpp)
new_test(Database/AlbumTest.cpp)
new_test(Database/LibraryDatabaseTest.cpp)
new_test(Database/TracksTest.cpp Common/TestTracks.cpp)
new_test(DynamicPlayback/ArtistMatchTest.cpp)

new_test(Equalizer/EqualizerTest.cpp)

new_test(Library/ImportCacheTest.cpp)
new_test(Library/LibraryManagerTest.cpp)
new_test(Lyrics/LyricsLogicTest.cpp)

new_test(Playlist/PlaylistTest.cpp Playlist/PlaylistTestUtils.cpp Common/TestTracks.cpp)
new_test(Playlist/PlaylistTrackModifyTest.cpp Playlist/PlaylistTestUtils.cpp Common/TestTracks.cpp)
new_test(Playlist/PlaylistFileTest.cpp Playlist/PlaylistTestUtils.cpp Common/TestTracks.cpp)
new_test(Playlist/PlaylistHandlerTest.cpp)
new_test(Playlist/PlaylistDbInterfaceTest.cpp Common/TestTracks.cpp)
new_test(Playlist/PlaylistShuffleTest.cpp Playlist/PlaylistTestUtils.cpp Common/TestTracks.cpp)
new_test(Playlist/ExternTracksPlaylistGeneratorTest.cpp Playlist/PlaylistTestUtils.cpp Common/TestTracks.cpp)
new_test(Playlist/PlaylistFromPathCreatorTest.cpp Playlist/PlaylistTestUtils.cpp Common/TestTracks.cpp)
new_test(Playlist/RepeatTest.cpp Playlist/PlaylistTestUtils.cpp Common/TestTracks.cpp)

new_test(PlayManager/PlayManagerTest.cpp)

new_test(Streaming/RadioStationParserTest.cpp)

new_test(StreamRecorder/StreamRecorderTest.cpp)
new_test(StreamRecorder/StreamRecorderUtilsTest.cpp)

new_test(Tagging/AlbumArtistTest.cpp Tagging/AbstractTaggingTest.cpp)
new_test(Tagging/CoverTest.cpp Tagging/AbstractTaggingTest.cpp)
new_test(Tagging/DiscnumberTest.cpp Tagging/AbstractTaggingTest.cpp)
new_test(Tagging/EditorTest.cpp)
new_test(Tagging/LyricsTest.cpp Tagging/AbstractTaggingTest.cpp)
new_test(Tagging/RatingTest.cpp Tagging/AbstractTaggingTest.cpp)
new_test(Tagging/TagFromPathTest.cpp)
new_test(Tagging/TaggingTest.cpp Tagging/AbstractTaggingTest.cpp)
new_test(Tagging/CoverEditTest.cpp Common/TestTracks.cpp)

new_test(Util/AlbumClassTest.cpp)
new_test(Util/UtilTest.cpp)
new_test(Util/AsyncWebAccessTest.cpp)
new_test(Util/CryptTest.cpp)
new_test(Util/DirectoryReaderTest.cpp Common/TestTracks.cpp)
new_test(Util/FileHelperTest.cpp)
new_test(Util/LanguageKeyTest.cpp)
new_test(Util/LanguageUtilTest.cpp)
new_test(Util/LibraryFilterTest.cpp)
new_test(Util/MetaDataTest.cpp)
new_test(Util/MetaDataListTest.cpp)
new_test(Util/MetaDataSortingTest.cpp)
new_test(Util/MimeDataTest.cpp ${CMAKE_SOURCE_DIR}/src/Gui/Utils/MimeData/CustomMimeData.cpp)
new_test(Util/PlaylistModeTest.cpp)
new_test(Util/SettingsTest.cpp)
new_test(Util/SetTest.cpp)
new_test(Util/CissearchTest.cpp)
new_test(Util/StandardPathTest.cpp)
new_test(Util/TreeTest.cpp)
new_test(Util/Ranges.cpp)
new_test(Util/StreamParserTest.cpp)
new_test(SmartPlaylists/ConverterTest.cpp)
new_test(SmartPlaylists/SmartPlaylistManagerTest.cpp)

=== src/Application/CMakeLists.txt ===
project(sayonara_application)

include_directories(
	${CMAKE_CURRENT_BINARY_DIR},
	${CMAKE_CURRENT_SOURCE_DIR}
)

file(GLOB_RECURSE SOURCES . *.cpp)
file(GLOB_RECURSE HEADERS . *.h)

set(APPLICATION_LIBRARIES
	sayonara_gui
)

add_library(${PROJECT_NAME} STATIC ${SOURCES} ${HEADERS})
target_link_libraries(${PROJECT_NAME}
	${APPLICATION_LIBRARIES}
	sayonara_dbus
	sayonara_utils
)

=== src/Components/CMakeLists.txt ===
project(sayonara_components)

set(CMAKE_AUTOUIC OFF)

set(COMPONENTS
	Bookmarks
	Broadcasting
	Converter
	Covers
	Directories
	DynamicPlayback
	Equalizer
	Engine
	Library
	LibraryManagement
	Lyrics
	MetaDataInfo
	Playlist
	PlaylistChooser
	PlayManager
	Preferences
	RemoteControl
	Session
	Shutdown
	Streaming
	Tagging
)

foreach(COMPONENT ${COMPONENTS})
	file(GLOB_RECURSE SOURCES ${COMPONENT} *.cpp)
	file(GLOB_RECURSE HEADERS ${COMPONENT} *.h)
endforeach()

qt5_add_resources(COMPONENT_RESOURCES_RCC
	${CMAKE_CURRENT_SOURCE_DIR}/Broadcasting/Broadcasting.qrc
	${CMAKE_CURRENT_SOURCE_DIR}/Lyrics/Lyrics.qrc
)

add_library(${PROJECT_NAME} STATIC ${HEADERS} ${SOURCES} ${COMPONENT_RESOURCES_RCC} Equalizer/Equalizer.cpp Equalizer/Equalizer.h)

target_link_libraries(${PROJECT_NAME}
	sayonara_database
	sayonara_interfaces

	${GSTREAMER_LIBRARIES}
	${GSTREAMER_BASE_LIBRARIES}
	${GSTREAMER_BASE_APP_LIBRARIES}

	Qt5::Svg
)

if( WITH_COTIRE )
	cotire(${PROJECT_NAME})
endif()

=== src/Interfaces/CMakeLists.txt ===
project(sayonara_interfaces)

file(GLOB_RECURSE SOURCES . *.cpp)
file(GLOB_RECURSE HEADERS . *.h)

add_library(${PROJECT_NAME} STATIC ${SOURCES} ${HEADERS} PlaylistInterface.h)
target_link_libraries(${PROJECT_NAME}
	sayonara_utils
)

if( WITH_COTIRE )
	cotire(${PROJECT_NAME})
endif()

## sayonara 1.8.0-beta1

=== debian/changelog ===
sayonara (1.8.0-beta1-1build3) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- William Grant <wgrant@ubuntu.com>  Mon, 01 Apr 2024 18:57:34 +1100

sayonara (1.8.0-beta1-1build2) noble; urgency=medium

  * No-change rebuild against libqt5core5t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Fri, 15 Mar 2024 07:03:05 +0000

sayonara (1.8.0-beta1-1build1) noble; urgency=medium

  * No-change rebuild against libglib2.0-0t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Fri, 08 Mar 2024 06:54:02 +0000

sayonara (1.8.0-beta1-1) unstable; urgency=medium

  * New upstream version.
  * debian/upstream/metadata: Set Bug-Submit and Repository.
  * debian/control: Use secure URI and update Standards-Version.
  * debian/patches: Remove patch, fixed in upstream.

 -- Steve Meliza <swm@swm1.com>  Thu, 25 Aug 2022 09:11:22 -0700

=== debian/control ===
Source: sayonara
Section: sound
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: kokoye2007 <kokoye2007@gmail.com>
Uploaders:
 Steve Meliza <swm@swm1.com>,
Rules-Requires-Root: no
Build-Depends:
 cmake (>= 3.8),
 debhelper-compat (= 13),
 dh-python,
 doxygen,
 libgstreamer-plugins-bad1.0-dev,
 libgstreamer-plugins-base1.0-dev,
 libgstreamer1.0-dev,
 libqt5svg5-dev,
 libtag1-dev,
 libtagc0-dev,
 pkg-config,
 python3:any,
 qtbase5-dev (>= 5.6),
 qttools5-dev,
 qttools5-dev-tools,
 zlib1g-dev,
Standards-Version: 4.6.1
Homepage: https://sayonara-player.com
Vcs-Git: https://salsa.debian.org/debian/sayonara.git
Vcs-Browser: https://salsa.debian.org/debian/sayonara

Package: sayonara
Architecture: any
Depends:
 gstreamer1.0-plugins-bad,
 gstreamer1.0-plugins-good,
 libqt5sql5-sqlite,
 libqt5svg5,
 python3-pydbus,
 ${misc:Depends},
 ${python3:Depends},
 ${shlibs:Depends},
Description: small, clear and fast audio player
 Sayonara is a small, clear and fast audio player for Linux
 written in C++, supported by the Qt framework. One of Sayonara's
 goals is intuitive and easy usablility.

## sayonara 1.9.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -5,8 +5,24 @@
 option(WITH_TESTS "Building with tests" OFF)
 option(WITH_COTIRE "Building with cotire PCH and compile time optimizations" OFF)
 option(LINK_GSTREAMER_PLUGINS "Link the most common GStreamer plugins into the binary. Used for the creation of AppImage files")
-option(WITH_CCACHE "Use CCache if available" OFF)
 option(DISABLE_NATIVE_DIR_DIALOGS "Disable native directory dialogs (problem for snap and flatpak)" OFF)
+option(GIT_REVISION "Add some git revision to the version string")
+
+include(cmake/Compiler.cmake)
+include(cmake/Packages.cmake)
+
+if(LINK_GSTREAMER_PLUGINS)
+	include(cmake/GStreamer.cmake)
+endif()
+
+if(WITH_COTIRE)
+	include(cmake/Cotire.cmake)
+	message("Compiling with Cotire")
+	add_definitions(-D__STRICT_ANSI__)
+else()
+	message("Compiling without Cotire")
+endif()
+
 
 get_property(HAS_64_SUFFIX GLOBAL PROPERTY FIND_LIBRARY_USE_LIB64_PATHS)
 if(HAS_64_SUFFIX)
@@ -17,7 +33,12 @@
 
 set(CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}")
 
-set(SAYONARA_VERSION "1.8.0-beta1")
+set(SAYONARA_VERSION "1.9.0-stable1")
+set(SAYONARA_REVISION ${GIT_REVISION})
+set(SAYONARA_FULL_VERSION ${SAYONARA_VERSION})
+if (SAYONARA_REVISION)
+	set(SAYONARA_FULL_VERSION "${SAYONARA_VERSION}-g${SAYONARA_REVISION}")
+endif()
 set(SAYONARA_INSTALL_PATH "${CMAKE_INSTALL_PREFIX}")
 set(SAYONARA_INSTALL_PREFIX "${CMAKE_INSTALL_PREFIX}")
 set(SAYONARA_INSTALL_BIN_PATH "${CMAKE_INSTALL_PREFIX}/bin/")

=== test/CMakeLists.txt ===
project(sayonara-test)

include(${CMAKE_SOURCE_DIR}/cmake/Packages.cmake)
include(${CMAKE_SOURCE_DIR}/cmake/NewTest.cmake)

if(POLICY CMP0071)
	cmake_policy(SET CMP0071 NEW)
endif()

set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTOUIC ON)
set(CMAKE_INCLUDE_CURRENT_DIR ON)

file(COPY ${CMAKE_SOURCE_DIR}/resources/player.db
	DESTINATION	${CMAKE_CURRENT_BINARY_DIR}
)

include_directories(${CMAKE_SOURCE_DIR}/src)
include_directories(${CMAKE_BINARY_DIR}/src)
include_directories(${CMAKE_BINARY_DIR}/src/3rdParty)
include_directories(${CMAKE_BINARY_DIR}/src/3rdParty/taglib)

include_directories(${CMAKE_SOURCE_DIR})
include_directories(${CMAKE_BINARY_DIR}/test)

pkg_check_modules(GSTREAMER_AUDIO gstreamer-audio-1.0 REQUIRED)
include_directories(${GSTREAMER_AUDIO_INCLUDE_DIRS})

set(RESOURCES
	resources/Test.qrc
	${CMAKE_CURRENT_SOURCE_DIR}/../resources/Database.qrc
	${CMAKE_CURRENT_SOURCE_DIR}/../resources/Resources.qrc
)

qt5_add_resources(RESOURCES_RCC
	${RESOURCES}
)

new_test(AudioConverter/AudioConverterTest.cpp)
new_test(Bookmarks/BookmarkStorageTest.cpp)
new_test(Common/FileSystemMockTest.cpp)
new_test(Covers/CoverFetchManagerTest.cpp)
new_test(Covers/CoverLocationTest.cpp)
new_test(Database/AlbumTest.cpp)
new_test(Database/ArtistTest.cpp)
new_test(Database/BasicQueryTest.cpp)
new_test(Database/LibraryDatabaseTest.cpp)
new_test(Database/PlaylistDatabaseTest.cpp)
new_test(Database/PodcastTest.cpp)
new_test(Database/TracksTest.cpp Common/TestTracks.cpp)
new_test(DynamicPlayback/ArtistMatchTest.cpp)
new_test(Engine/BroadcastTest.cpp)
new_test(Engine/CallbackTest.cpp)
new_test(Engine/EngineUtilsTest.cpp)
new_test(Equalizer/EqualizerTest.cpp)
new_test(History/HistoryTest.cpp Common/TestTracks.cpp)
new_test(Library/CacheThreadTest.cpp)
new_test(Library/CopyThreadTest.cpp)
new_test(Library/GenreFetcherTest.cpp)
new_test(Library/GenreTreeBuilderTest.cpp)
new_test(Library/ImportCacheTest.cpp)
new_test(Library/LibraryImporterTest.cpp)
new_test(Library/LibraryManagerTest.cpp)
new_test(Library/LocalLibraryTest.cpp)
new_test(Library/ReloadThreadTest.cpp Common/TestTracks.cpp)
new_test(LibraryManagement/LibraryPluginHandlerTest.cpp)
new_test(Lyrics/LyricsLogicTest.cpp)
new_test(PlayManager/PlayManagerTest.cpp)
new_test(Playlist/LocalPathPlaylistCreatorTest.cpp Playlist/PlaylistTestUtils.cpp Common/TestTracks.cpp)
new_test(Playlist/LocalPathProcessorTest.cpp Playlist/PlaylistTestUtils.cpp Common/TestTracks.cpp)
new_test(Playlist/PlaylistDbInterfaceTest.cpp Common/TestTracks.cpp)
new_test(Playlist/PlaylistFileTest.cpp Playlist/PlaylistTestUtils.cpp Common/TestTracks.cpp)
new_test(Playlist/PlaylistHandlerTest.cpp Common/TestTracks.cpp)
new_test(Playlist/PlaylistShuffleTest.cpp Playlist/PlaylistTestUtils.cpp Common/TestTracks.cpp)
new_test(Playlist/PlaylistTest.cpp Playlist/PlaylistTestUtils.cpp Common/TestTracks.cpp)
new_test(Playlist/PlaylistTrackModifyTest.cpp Playlist/PlaylistTestUtils.cpp Common/TestTracks.cpp)
new_test(Playlist/RepeatTest.cpp Playlist/PlaylistTestUtils.cpp Common/TestTracks.cpp)
new_test(Settings/SettingConverterTest.cpp)
new_test(Settings/SettingsNotifierTest.cpp)
new_test(SmartPlaylists/ConverterTest.cpp)
new_test(SmartPlaylists/ListeningDateTest.cpp)
new_test(SmartPlaylists/SmartPlaylistManagerTest.cpp)
new_test(StreamRecorder/StreamRecorderTest.cpp)
new_test(StreamRecorder/StreamRecorderUtilsTest.cpp)
new_test(Streaming/RadioBrowserParserTest.cpp)
new_test(Streaming/RadioStationParserTest.cpp)
new_test(Streaming/StreamHandlerTest.cpp)
new_test(Tagging/AlbumArtistTest.cpp Tagging/AbstractTaggingTest.cpp)
new_test(Tagging/CoverEditTest.cpp Common/TestTracks.cpp)
new_test(Tagging/CoverTest.cpp Tagging/AbstractTaggingTest.cpp)
new_test(Tagging/DiscnumberTest.cpp Tagging/AbstractTaggingTest.cpp)
new_test(Tagging/EditorTest.cpp)
new_test(Tagging/LyricsTest.cpp Tagging/AbstractTaggingTest.cpp)
new_test(Tagging/RatingTest.cpp Tagging/AbstractTaggingTest.cpp)
new_test(Tagging/TagFromPathTest.cpp)
new_test(Tagging/TaggingTest.cpp)
new_test(Util/ASXParserTest.cpp)
new_test(Util/AlbumClassTest.cpp)
new_test(Util/AsyncWebAccessTest.cpp)
new_test(Util/CissearchTest.cpp)
new_test(Util/CryptTest.cpp)
new_test(Util/DirectoryReaderTest.cpp Common/TestTracks.cpp)
new_test(Util/FileHelperTest.cpp)
new_test(Util/LanguageKeyTest.cpp)
new_test(Util/LanguageUtilTest.cpp)
new_test(Util/LibraryFilterTest.cpp)
new_test(Util/MetaDataListTest.cpp)
new_test(Util/MetaDataSortingTest.cpp)
new_test(Util/MetaDataTest.cpp)
new_test(Util/MimeDataTest.cpp ${CMAKE_SOURCE_DIR}/src/Gui/Utils/MimeData/CustomMimeData.cpp)
new_test(Util/PlaylistModeTest.cpp)
new_test(Util/PlsParserTest.cpp)
new_test(Util/PodcastParserTest.cpp)
new_test(Util/Ranges.cpp)
new_test(Util/SetTest.cpp)
new_test(Util/SettingsTest.cpp)
new_test(Util/SortingTest.cpp)
new_test(Util/StandardPathTest.cpp)
new_test(Util/StreamParserTest.cpp)
new_test(Util/TreeTest.cpp)
new_test(Util/UtilTest.cpp)

## sayonara 1.9.0-stable1

=== debian/changelog ===
sayonara (1.9.0-stable1-0.1~mx21+1) mx; urgency=medium

  * New upstream version.
  * Update debian/copyright to current year.

 -- Steven Pusser <stevep@mxlinux.org>  Mon, 29 Jan 2024 13:58:31 -0800

sayonara (1.8.0-beta1-1~bpo11+1) bullseye-backports; urgency=medium

  * Rebuild for bullseye-backports.

 -- Boyuan Yang <byang@debian.org>  Sat, 05 Nov 2022 16:26:16 -0400

sayonara (1.7.0-stable3-0.2~bpo11+1) bullseye-backports; urgency=medium

  * Rebuild for bullseye-backports.

 -- Boyuan Yang <byang@debian.org>  Wed, 25 Aug 2021 17:59:56 -0400

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

include /usr/share/dpkg/architecture.mk

%:
	dh $@ --with python3 --buildsystem=cmake

# No dbgsym packages:
override_dh_strip:
	dh_strip --no-automatic-dbgsym

## sayonara 1.10.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -33,7 +33,7 @@
 
 set(CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}")
 
-set(SAYONARA_VERSION "1.9.0-stable1")
+set(SAYONARA_VERSION "1.10.0-stable1")
 set(SAYONARA_REVISION ${GIT_REVISION})
 set(SAYONARA_FULL_VERSION ${SAYONARA_VERSION})
 if (SAYONARA_REVISION)

=== test/CMakeLists.txt ===
--- 
+++ 
@@ -39,21 +39,29 @@
 new_test(AudioConverter/AudioConverterTest.cpp)
 new_test(Bookmarks/BookmarkStorageTest.cpp)
 new_test(Common/FileSystemMockTest.cpp)
+new_test(Common/LibraryDatabaseProviderTest.cpp)
+new_test(Covers/AudioscrobblerTest.cpp)
 new_test(Covers/CoverFetchManagerTest.cpp)
 new_test(Covers/CoverLocationTest.cpp)
 new_test(Database/AlbumTest.cpp)
 new_test(Database/ArtistTest.cpp)
 new_test(Database/BasicQueryTest.cpp)
+new_test(Database/FixesTest.cpp)
 new_test(Database/LibraryDatabaseTest.cpp)
 new_test(Database/PlaylistDatabaseTest.cpp)
 new_test(Database/PodcastTest.cpp)
 new_test(Database/TracksTest.cpp Common/TestTracks.cpp)
+new_test(Directories/DirectorySelectionHandlerTest.cpp)
 new_test(DynamicPlayback/ArtistMatchTest.cpp)
+new_test(DynamicPlayback/DynamicPlaybackHandlerTest.cpp)
+new_test(DynamicPlayback/LfmSimilarArtistFetcherTest.cpp)
+new_test(DynamicPlayback/LfmSimilarArtistParserTest.cpp)
 new_test(Engine/BroadcastTest.cpp)
 new_test(Engine/CallbackTest.cpp)
 new_test(Engine/EngineUtilsTest.cpp)
 new_test(Equalizer/EqualizerTest.cpp)
 new_test(History/HistoryTest.cpp Common/TestTracks.cpp)
+new_test(LastFm/ScrobbleTest.cpp)
 new_test(Library/CacheThreadTest.cpp)
 new_test(Library/CopyThreadTest.cpp)
 new_test(Library/GenreFetcherTest.cpp)
@@ -65,12 +73,15 @@
 new_test(Library/ReloadThreadTest.cpp Common/TestTracks.cpp)
 new_test(LibraryManagement/LibraryPluginHandlerTest.cpp)
 new_test(Lyrics/LyricsLogicTest.cpp)
+new_test(Lyrics/LyricsServerProviderTest.cpp)
 new_test(PlayManager/PlayManagerTest.cpp)
+new_test(Playlist/LibraryPlaylistInteractorTest.cpp)
 new_test(Playlist/LocalPathPlaylistCreatorTest.cpp Playlist/PlaylistTestUtils.cpp Common/TestTracks.cpp)
 new_test(Playlist/LocalPathProcessorTest.cpp Playlist/PlaylistTestUtils.cpp Common/TestTracks.cpp)
 new_test(Playlist/PlaylistDbInterfaceTest.cpp Common/TestTracks.cpp)
 new_test(Playlist/PlaylistFileTest.cpp Playlist/PlaylistTestUtils.cpp Common/TestTracks.cpp)
 new_test(Playlist/PlaylistHandlerTest.cpp Common/TestTracks.cpp)
+new_test(Playlist/PlaylistLoaderTest.cpp)
 new_test(Playlist/PlaylistShuffleTest.cpp Playlist/PlaylistTestUtils.cpp Common/TestTracks.cpp)
 new_test(Playlist/PlaylistTest.cpp Playlist/PlaylistTestUtils.cpp Common/TestTracks.cpp)
 new_test(Playlist/PlaylistTrackModifyTest.cpp Playlist/PlaylistTestUtils.cpp Common/TestTracks.cpp)
@@ -104,6 +115,7 @@
 new_test(Util/LanguageKeyTest.cpp)
 new_test(Util/LanguageUtilTest.cpp)
 new_test(Util/LibraryFilterTest.cpp)
+new_test(Util/M3UParserTest.cpp)
 new_test(Util/MetaDataListTest.cpp)
 new_test(Util/MetaDataSortingTest.cpp)
 new_test(Util/MetaDataTest.cpp)

## sayonara 1.10.0-stable1

=== debian/changelog ===
sayonara (1.10.0-stable1-3) unstable; urgency=medium

  * Team upload.
  * Rebuild against taglib 2.x.
  * debian/control: Update libtag1-dev => libtag-dev from taglib 2.x.

 -- Boyuan Yang <byang@debian.org>  Fri, 10 Jan 2025 19:15:18 -0500

sayonara (1.10.0-stable1-2) unstable; urgency=medium

  * Fix mismatched types in call to std:max

 -- Steve Meliza <swm@swm1.com>  Tue, 13 Aug 2024 11:25:22 -0700

sayonara (1.10.0-stable1-1) unstable; urgency=medium

  * New upstream version. (Closes: #1069533)

 -- Steve Meliza <swm@swm1.com>  Sat, 10 Aug 2024 20:26:36 -0700

=== debian/control ===
Source: sayonara
Section: sound
Priority: optional
Maintainer: kokoye2007 <kokoye2007@gmail.com>
Uploaders:
 Steve Meliza <swm@swm1.com>,
Rules-Requires-Root: no
Build-Depends:
 cmake (>= 3.8),
 debhelper-compat (= 13),
 dh-python,
 doxygen,
 libgstreamer-plugins-bad1.0-dev,
 libgstreamer-plugins-base1.0-dev,
 libgstreamer1.0-dev,
 libqt5svg5-dev,
 libtag-dev,
 libtagc0-dev,
 pkgconf,
 python3,
 qtbase5-dev (>= 5.6),
 qttools5-dev,
 qttools5-dev-tools,
 zlib1g-dev,
Standards-Version: 4.7.0
Homepage: https://sayonara-player.com
Vcs-Git: https://salsa.debian.org/debian/sayonara.git
Vcs-Browser: https://salsa.debian.org/debian/sayonara

Package: sayonara
Architecture: any
Depends: gstreamer1.0-plugins-bad,
		 gstreamer1.0-plugins-good,
         libqt5sql5-sqlite,
		 libqt5svg5,
         ${python3:Depends},
         ${misc:Depends},
         ${shlibs:Depends}
Suggests:
         python3-pydbus
Description: fast and powerful audio player and library manager
 Many supported music and playlist formats
 Media library with search function and tag editor
 Display directories, covers and/or meta data.
 Genre organization in tree
 Playlist view organized in tabs
 Smart and dynamic plsylists
 Lyrics
 Equalizer
 Customizable spectrum analyzer and level meter
 Audio converter
 Last.FM, Soma.fm and soundcloud support radio and scrobbling
 Internet streams, podcasts and record function
 Broadcasting
 Multimedia keys and Mpris 2 support
 Shutdown function

## sayonara 1.11.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -33,7 +33,7 @@
 
 set(CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}")
 
-set(SAYONARA_VERSION "1.10.0-stable1")
+set(SAYONARA_VERSION "1.11.0-stable1")
 set(SAYONARA_REVISION ${GIT_REVISION})
 set(SAYONARA_FULL_VERSION ${SAYONARA_VERSION})
 if (SAYONARA_REVISION)

=== dist/CMakeLists.txt ===
execute_process(COMMAND env LC_TIME="en_US.utf8" date "+%a %b %d %Y" OUTPUT_VARIABLE SAYONARA_DATE_TODAY)
string(REGEX REPLACE "\n$" "" SAYONARA_DATE_TODAY "${SAYONARA_DATE_TODAY}")
string(REGEX MATCH "[0-9]+(\.[0-9]+)+" SAYONARA_VERSION_BASE "${SAYONARA_VERSION}")
string(REGEX MATCH "[a-z]+[0-9]+" SAYONARA_VERSION_RELEASE ${SAYONARA_VERSION})

configure_file(${CMAKE_CURRENT_SOURCE_DIR}/rpm/sayonara.spec.in ${CMAKE_CURRENT_BINARY_DIR}/sayonara.spec @ONLY)

=== resources/CMakeLists.txt ===
--- 
+++ 
@@ -1,6 +1,10 @@
 project(say_resources)
 
+string(TIMESTAMP APPSTREAM_BUILD_DATE "%Y-%m-%d")
 configure_file(version.in ${CMAKE_BINARY_DIR}/version @ONLY)
+configure_file(com.sayonara-player.Sayonara.appdata.xml.in
+               ${CMAKE_CURRENT_BINARY_DIR}/com.sayonara-player.Sayonara.appdata.xml
+               @ONLY)
 
 # manpage
 find_program(GZIP_BINARY
@@ -38,7 +42,7 @@
 
 install(FILES "com.sayonara-player.Sayonara.desktop"
         DESTINATION share/applications)
-install(FILES "sayonara.appdata.xml"
+install(FILES "${CMAKE_CURRENT_BINARY_DIR}/com.sayonara-player.Sayonara.appdata.xml"
         DESTINATION share/metainfo)
 install(DIRECTORY "logos/"
         DESTINATION share/icons/hicolor)

=== src/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.8)
project(sayonara)

include(${CMAKE_SOURCE_DIR}/cmake/UnixEnvironment.cmake)

include_directories(${CMAKE_CURRENT_SOURCE_DIR})
include_directories(${CMAKE_CURRENT_BINARY_DIR})

# absolute linker paths are no longer supoorted in -l parameter
# use -L for path and -l for library itself
if(POLICY CMP0003)
	cmake_policy(SET CMP0003 NEW)
endif()

# no more escaping of preprocessor definitions
if(POLICY CMP0005)
	cmake_policy(SET CMP0005 NEW)
endif()

# Run Automoc/Autouic over autogenerated source files (e.g. from qrc files)
if(POLICY CMP0071)
	cmake_policy(SET CMP0071 NEW)
endif()

set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/bin)
set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/lib)

if( NOT DEFINED CMAKE_BUILD_TYPE OR NOT CMAKE_BUILD_TYPE )
	message("Use standard build type \"Release\"")
	set(CMAKE_BUILD_TYPE "Release")
endif()

# Macros.h.in
set(SAYONARA_WITH_DBUS 1)
set(SAYONARA_WITH_SHUTDOWN 1)

configure_file(Macros.h.in "${CMAKE_CURRENT_BINARY_DIR}/Utils/Macros.h" @ONLY)

set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTOUIC OFF)
set(CMAKE_INCLUDE_CURRENT_DIR ON)

add_subdirectory(Application)
add_subdirectory(Components)
add_subdirectory(Database)
add_subdirectory(DBus)
add_subdirectory(Interfaces)
add_subdirectory(Gui)
add_subdirectory(Languages)
add_subdirectory(Utils)

qt5_add_resources(DATABASE_RCC
	${CMAKE_CURRENT_SOURCE_DIR}/../resources/Database.qrc
	${CMAKE_CURRENT_SOURCE_DIR}/../resources/Resources.qrc
)

add_executable(${PROJECT_NAME} Main.cpp ${QM_FILES} ${DATABASE_RCC})

target_link_libraries(${PROJECT_NAME}
	sayonara_application
	sayonara_languages

	${OS_LIBRARIES}
)

add_executable("create-database" CreateDB.cpp ${DATABASE_RCC})
target_link_libraries("create-database"
	sayonara_utils
	sayonara_database
	Qt5::Widgets
)

install(TARGETS ${PROJECT_NAME} DESTINATION bin)

=== test/CMakeLists.txt ===
--- 
+++ 
@@ -86,6 +86,7 @@
 new_test(Playlist/PlaylistTest.cpp Playlist/PlaylistTestUtils.cpp Common/TestTracks.cpp)
 new_test(Playlist/PlaylistTrackModifyTest.cpp Playlist/PlaylistTestUtils.cpp Common/TestTracks.cpp)
 new_test(Playlist/RepeatTest.cpp Playlist/PlaylistTestUtils.cpp Common/TestTracks.cpp)
+new_test(Playlist/StopBehaviorTest.cpp)
 new_test(Settings/SettingConverterTest.cpp)
 new_test(Settings/SettingsNotifierTest.cpp)
 new_test(SmartPlaylists/ConverterTest.cpp)

=== src/DBus/CMakeLists.txt ===
project(sayonara_dbus)

include_directories(${CMAKE_CURRENT_BINARY_DIR})

file(GLOB_RECURSE DBUS_SOURCES . *.cpp)
file(GLOB_RECURSE DBUS_HEADERS . *.h)

qt5_add_dbus_adaptor(DBUS_SOURCES
	${CMAKE_CURRENT_SOURCE_DIR}/resources/org.mpris.MediaPlayer2.xml
	${CMAKE_SOURCE_DIR}/src/DBus/DBusMPRIS.h
	Dbus::Mpris::MediaPlayer2
	org_mpris_media_player2_adaptor
	OrgMprisMediaPlayer2Adaptor
)

qt5_add_dbus_adaptor(DBUS_SOURCES
	${CMAKE_CURRENT_SOURCE_DIR}/resources/org.mpris.MediaPlayer2.Player.xml
	${CMAKE_SOURCE_DIR}/src/DBus/DBusMPRIS.h
	Dbus::Mpris::MediaPlayer2
	org_mpris_media_player2_player_adaptor
	OrgMprisMediaPlayer2PlayerAdaptor
)

qt5_add_dbus_interface(DBUS_SOURCES
	${CMAKE_CURRENT_SOURCE_DIR}/resources/org.freedesktop.Notifications.xml
	Notifications
)

qt5_add_dbus_interface(DBUS_SOURCES
	${CMAKE_CURRENT_SOURCE_DIR}/resources/org.mate.SettingsDaemon.MediaKeys.xml
	mate_settings_daemon
)

qt5_add_dbus_interface(DBUS_SOURCES
	${CMAKE_CURRENT_SOURCE_DIR}/resources/org.gnome.SettingsDaemon.MediaKeys.xml
	gnome_settings_daemon
)

qt5_add_dbus_interface(DBUS_SOURCES 
	${CMAKE_CURRENT_SOURCE_DIR}/resources/org.gnome.SessionManager.xml
	SessionManager
)

add_library(${PROJECT_NAME} STATIC ${DBUS_SOURCES} ${DBUS_HEADERS})
target_link_libraries(${PROJECT_NAME}
	sayonara_gui
	sayonara_interfaces

	Qt5::Core
	Qt5::DBus
)

install(
	FILES sayonara-query sayonara-ctl 
	DESTINATION bin
	PERMISSIONS 
		OWNER_READ OWNER_WRITE OWNER_EXECUTE 
		GROUP_READ GROUP_EXECUTE 
		WORLD_READ WORLD_EXECUTE 
)

=== src/Database/CMakeLists.txt ===
project(sayonara_database)

# No moc files in database
set(CMAKE_AUTOMOC OFF)

file(GLOB_RECURSE SOURCES . *.cpp)
file(GLOB_RECURSE HEADERS . *.h)

add_library(${PROJECT_NAME} STATIC ${SOURCES} ${HEADERS})
target_link_libraries(${PROJECT_NAME}
	sayonara_utils
	Qt5::Sql
)

if( WITH_COTIRE )
	cotire(${PROJECT_NAME})
endif()

=== src/Gui/CMakeLists.txt ===
project(sayonara_gui)

set(CMAKE_AUTOUIC ON)

file(GLOB_RECURSE GUI_SOURCES . *.cpp)
file(GLOB_RECURSE GUI_HEADERS . *.h)

set(GUI_RESOURCES
	Resources/Icons.qrc
	SomaFM/SomaFMIcons.qrc
	Soundcloud/SoundcloudIcons.qrc
)

qt5_add_resources(GUI_RESOURCES_RCC
	${GUI_RESOURCES}
)

add_library(${PROJECT_NAME} STATIC ${GUI_SOURCES} ${GUI_HEADERS} ${GUI_RESOURCES_RCC})
target_link_libraries(${PROJECT_NAME}
	sayonara_components

	Qt5::Gui
	Qt5::Widgets
)

if( WITH_COTIRE )
	cotire(${PROJECT_NAME})
endif()

=== src/Interfaces/CMakeLists.txt ===
project(sayonara_interfaces)

file(GLOB_RECURSE SOURCES . *.cpp)
file(GLOB_RECURSE HEADERS . *.h)

add_library(${PROJECT_NAME} STATIC ${SOURCES} ${HEADERS})
target_link_libraries(${PROJECT_NAME}
	sayonara_utils
)

if( WITH_COTIRE )
	cotire(${PROJECT_NAME})
endif()

=== src/Languages/CMakeLists.txt ===
project(sayonara_languages)

file(GLOB TS_FILES . *.ts)

set(TRANSLATION_TARGET_PATH
	share/sayonara/translations
)

qt5_add_translation(QM_FILES ${TS_FILES})
install(DIRECTORY ./icons
	DESTINATION ${TRANSLATION_TARGET_PATH}
	FILES_MATCHING PATTERN "*.png"
)

add_library(${PROJECT_NAME} STATIC ${QM_FILES})

install(FILES ${QM_FILES} DESTINATION ${TRANSLATION_TARGET_PATH})

=== src/Utils/CMakeLists.txt ===
project(sayonara_utils)

pkg_check_modules(ZLIB REQUIRED zlib)
include_directories(${ZLIB_INCLUDE_DIRS})
link_directories(${TAGLIB_LIBRARY_DIRS})

file(GLOB_RECURSE SOURCES . *.cpp)
file(GLOB_RECURSE HEADERS . *.h)

add_library(${PROJECT_NAME} STATIC ${SOURCES} ${HEADERS} ${MOC_FILES})

target_link_libraries(${PROJECT_NAME}
	Qt5::Core
	Qt5::Network
	Qt5::Xml
	Qt5::Gui
	Qt5::DBus

	${TAGLIB_LIBRARIES}
	${ZLIB_LIBRARIES}
)

if( WITH_COTIRE )
	cotire(${PROJECT_NAME})
endif()

## sayonara 1.11.0-beta1

=== debian/changelog ===
sayonara (1.11.0-beta1-1) unstable; urgency=medium

  * New upstream version.

 -- Steve Meliza <swm@swm1.com>  Fri, 28 Mar 2025 20:26:11 -0700

sayonara (1.10.0-stable1-4) unstable; urgency=medium

  * Team upload.
  * debian/control: Fix package description format. (Closes: #1080292)
  * debian/control: Use build-dep packages from taglib 2.x.

 -- Boyuan Yang <byang@debian.org>  Sun, 09 Feb 2025 13:26:33 -0500

=== debian/control ===
Source: sayonara
Section: sound
Priority: optional
Maintainer: kokoye2007 <kokoye2007@gmail.com>
Uploaders:
 Steve Meliza <swm@swm1.com>,
Rules-Requires-Root: no
Build-Depends:
 cmake (>= 3.8),
 debhelper-compat (= 13),
 dh-python,
 doxygen,
 libgstreamer-plugins-bad1.0-dev,
 libgstreamer-plugins-base1.0-dev,
 libgstreamer1.0-dev,
 libqt5svg5-dev,
 libtag-dev,
 libtag-c-dev,
 pkgconf,
 python3,
 qtbase5-dev (>= 5.6),
 qttools5-dev,
 qttools5-dev-tools,
 zlib1g-dev,
Standards-Version: 4.7.0
Homepage: https://sayonara-player.com
Vcs-Git: https://salsa.debian.org/debian/sayonara.git
Vcs-Browser: https://salsa.debian.org/debian/sayonara

Package: sayonara
Architecture: any
Depends:
 gstreamer1.0-plugins-bad,
 gstreamer1.0-plugins-good,
 libqt5sql5-sqlite,
 libqt5svg5,
 ${python3:Depends},
 ${misc:Depends},
 ${shlibs:Depends},
Suggests:
 python3-pydbus,
Description: fast and powerful audio player and library manager
 Sayonara is a fast and powerful audio player and library manager
 with various functionalities:
  - Many supported music and playlist formats
  - Media library with search function and tag editor
  - Display directories, covers and/or meta data.
  - Genre organization in tree
  - Playlist view organized in tabs
  - Smart and dynamic plsylists
  - Lyrics
  - Equalizer
  - Customizable spectrum analyzer and level meter
  - Audio converter
  - Last.FM, Soma.fm and soundcloud support radio and scrobbling
  - Internet streams, podcasts and record function
  - Broadcasting
  - Multimedia keys and Mpris 2 support
  - Shutdown function

## sayonara 1.11.0-stable2

=== debian/changelog ===
sayonara (1.11.0-stable2-1) unstable; urgency=medium

  * New upstream version.
  * d/patches: Fix version string

 -- Steve Meliza <swm@swm1.com>  Sat, 13 Sep 2025 19:41:32 -0700

=== debian/rules ===
--- 
+++ 
@@ -9,7 +9,3 @@
 
 %:
 	dh $@ --with python3 --buildsystem=cmake
-
-# No dbgsym packages:
-override_dh_strip:
-	dh_strip --no-automatic-dbgsym

=== debian/watch ===
version=4
opts="searchmode=plain" \
  https://gitlab.com/luciocarreras/sayonara-player/tags?sort=updated_desc -/archive/(\d\S+)/.*\.zip
